Index: formats/format_wav.c
===================================================================
--- formats/format_wav.c	(revision 10193)
+++ formats/format_wav.c	(working copy)
@@ -49,30 +49,16 @@
 
 /* Portions of the conversion code are by guido@sienanet.it */
 
-struct ast_filestream {
-	void *reserved[AST_RESERVED_POINTERS];
-	/* This is what a filestream means to us */
-	FILE *f; /* Descriptor */
+#define	WAV_BUF_SIZE	320
+
+struct wav_desc {	/* format-specific parameters */
 	int bytes;
 	int needsgain;
-	struct ast_frame fr;				/* Frame information */
-	char waste[AST_FRIENDLY_OFFSET];	/* Buffer for sending frames, etc */
-	char empty;							/* Empty character */
-	short buf[160];	
-	int foffset;
 	int lasttimeout;
 	int maxlen;
 	struct timeval last;
 };
 
-
-AST_MUTEX_DEFINE_STATIC(wav_lock);
-static int glistcnt = 0;
-
-static char *name = "wav";
-static char *desc = "Microsoft WAV format (8000hz Signed Linear)";
-static char *exts = "wav";
-
 #define BLOCKSIZE 160
 
 #define GAIN 2		/* 2^GAIN is the multiple to increase the volume by */
@@ -333,135 +319,90 @@
 	return 0;
 }
 
-static struct ast_filestream *wav_open(FILE *f)
+static int wav_open(struct ast_filestream *s)
 {
 	/* We don't have any header to read or anything really, but
 	   if we did, it would go here.  We also might want to check
 	   and be sure it's a valid file.  */
-	struct ast_filestream *tmp;
-	if ((tmp = malloc(sizeof(struct ast_filestream)))) {
-		memset(tmp, 0, sizeof(struct ast_filestream));
-		if ((tmp->maxlen = check_header(f)) < 0) {
-			free(tmp);
-			return NULL;
-		}
-		if (ast_mutex_lock(&wav_lock)) {
-			ast_log(LOG_WARNING, "Unable to lock wav list\n");
-			free(tmp);
-			return NULL;
-		}
-		tmp->f = f;
-		tmp->needsgain = 1;
-		tmp->fr.data = tmp->buf;
-		tmp->fr.frametype = AST_FRAME_VOICE;
-		tmp->fr.subclass = AST_FORMAT_SLINEAR;
-		/* datalen will vary for each frame */
-		tmp->fr.src = name;
-		tmp->fr.mallocd = 0;
-		tmp->bytes = 0;
-		glistcnt++;
-		ast_mutex_unlock(&wav_lock);
-		ast_update_use_count();
-	}
-	return tmp;
+	struct wav_desc *tmp = (struct wav_desc *)s->private;
+	if ((tmp->maxlen = check_header(s->f)) < 0)
+		return -1;
+	return 0;
 }
 
-static struct ast_filestream *wav_rewrite(FILE *f, const char *comment)
+static int wav_rewrite(struct ast_filestream *s, const char *comment)
 {
 	/* We don't have any header to read or anything really, but
 	   if we did, it would go here.  We also might want to check
 	   and be sure it's a valid file.  */
-	struct ast_filestream *tmp;
-	if ((tmp = malloc(sizeof(struct ast_filestream)))) {
-		memset(tmp, 0, sizeof(struct ast_filestream));
-		if (write_header(f)) {
-			free(tmp);
-			return NULL;
-		}
-		if (ast_mutex_lock(&wav_lock)) {
-			ast_log(LOG_WARNING, "Unable to lock wav list\n");
-			free(tmp);
-			return NULL;
-		}
-		tmp->f = f;
-		glistcnt++;
-		ast_mutex_unlock(&wav_lock);
-		ast_update_use_count();
-	} else
-		ast_log(LOG_WARNING, "Out of memory\n");
-	return tmp;
+
+	if (write_header(s->f))
+		return -1;
+	return 0;
 }
 
 static void wav_close(struct ast_filestream *s)
 {
 	char zero = 0;
-	if (ast_mutex_lock(&wav_lock)) {
-		ast_log(LOG_WARNING, "Unable to lock wav list\n");
-		return;
-	}
-	glistcnt--;
-	ast_mutex_unlock(&wav_lock);
-	ast_update_use_count();
+	struct wav_desc *fs = (struct wav_desc *)s->private;
 	/* Pad to even length */
-	if (s->bytes & 0x1)
+	if (fs->bytes & 0x1)
 		fwrite(&zero, 1, 1, s->f);
-	fclose(s->f);
-	free(s);
-	s = NULL;
 }
 
 static struct ast_frame *wav_read(struct ast_filestream *s, int *whennext)
 {
 	int res;
-	int delay;
+	int samples;	/* actual samples read */
 	int x;
-	short tmp[sizeof(s->buf) / 2];
-	int bytes = sizeof(tmp);
+	short *tmp;
+	int bytes = WAV_BUF_SIZE;	/* in bytes */
 	off_t here;
 	/* Send a frame from the file to the appropriate channel */
+	struct wav_desc *fs = (struct wav_desc *)s->private;
+
 	here = ftell(s->f);
-	if ((s->maxlen - here) < bytes)
-		bytes = s->maxlen - here;
+	if (fs->maxlen - here < bytes)		/* truncate if necessary */
+		bytes = fs->maxlen - here;
 	if (bytes < 0)
 		bytes = 0;
 /* 	ast_log(LOG_DEBUG, "here: %d, maxlen: %d, bytes: %d\n", here, s->maxlen, bytes); */
+	s->fr.frametype = AST_FRAME_VOICE;
+	s->fr.subclass = AST_FORMAT_SLINEAR;
+	s->fr.mallocd = 0;
+	FR_SET_BUF(&s->fr, s->buf, AST_FRIENDLY_OFFSET, bytes);
 	
-	if ( (res = fread(tmp, 1, bytes, s->f)) <= 0 ) {
-		if (res) {
+	if ( (res = fread(s->fr.data, 1, s->fr.datalen, s->f)) <= 0 ) {
+		if (res)
 			ast_log(LOG_WARNING, "Short read (%d) (%s)!\n", res, strerror(errno));
-		}
 		return NULL;
 	}
+	s->fr.datalen = res;
+	s->fr.samples = samples = res / 2;
 
+	tmp = (short *)(s->fr.data);
 #if __BYTE_ORDER == __BIG_ENDIAN
-	for( x = 0; x < sizeof(tmp)/2; x++) tmp[x] = (tmp[x] << 8) | ((tmp[x] & 0xff00) >> 8);
+	/* file format is little endian so we need to swap */
+	for( x = 0; x < samples; x++)
+		tmp[x] = (tmp[x] << 8) | ((tmp[x] & 0xff00) >> 8);
 #endif
 
-	if (s->needsgain) {
-		for (x=0;x<sizeof(tmp)/2;x++)
+	if (fs->needsgain) {
+		for (x=0; x < samples; x++) {
 			if (tmp[x] & ((1 << GAIN) - 1)) {
 				/* If it has data down low, then it's not something we've artificially increased gain
 				   on, so we don't need to gain adjust it */
-				s->needsgain = 0;
+				fs->needsgain = 0;
+				break;
 			}
-	}
-	if (s->needsgain) {
-		for (x=0;x<sizeof(tmp)/2;x++) {
-			s->buf[x] = tmp[x] >> GAIN;
 		}
-	} else {
-		memcpy(s->buf, tmp, sizeof(s->buf));
+		if (fs->needsgain) {
+			for (x=0; x < samples; x++)
+				tmp[x] = tmp[x] >> GAIN;
+		}
 	}
 			
-	delay = res / 2;
-	s->fr.frametype = AST_FRAME_VOICE;
-	s->fr.subclass = AST_FORMAT_SLINEAR;
-	s->fr.offset = AST_FRIENDLY_OFFSET;
-	s->fr.datalen = res;
-	s->fr.data = s->buf;
-	s->fr.mallocd = 0;
-	s->fr.samples = delay;
-	*whennext = delay;
+	*whennext = samples;
 	return &s->fr;
 }
 
@@ -471,6 +412,8 @@
 	int x;
 	short tmp[8000], *tmpi;
 	float tmpf;
+	struct wav_desc *s = (struct wav_desc *)fs->private;
+
 	if (f->frametype != AST_FRAME_VOICE) {
 		ast_log(LOG_WARNING, "Asked to write non-voice frame!\n");
 		return -1;
@@ -490,33 +433,28 @@
 	printf("Data Length: %d\n", f->datalen);
 #endif	
 
-	if (fs->buf) {
-		tmpi = f->data;
-		/* Volume adjust here to accomodate */
-		for (x=0;x<f->datalen/2;x++) {
-			tmpf = ((float)tmpi[x]) * ((float)(1 << GAIN));
-			if (tmpf > 32767.0)
-				tmpf = 32767.0;
-			if (tmpf < -32768.0)
-				tmpf = -32768.0;
-			tmp[x] = tmpf;
-			tmp[x] &= ~((1 << GAIN) - 1);
+	tmpi = f->data;
+	/* Volume adjust here to accomodate */
+	for (x=0;x<f->datalen/2;x++) {
+		tmpf = ((float)tmpi[x]) * ((float)(1 << GAIN));
+		if (tmpf > 32767.0)
+			tmpf = 32767.0;
+		if (tmpf < -32768.0)
+			tmpf = -32768.0;
+		tmp[x] = tmpf;
+		tmp[x] &= ~((1 << GAIN) - 1);
 
 #if __BYTE_ORDER == __BIG_ENDIAN
-			tmp[x] = (tmp[x] << 8) | ((tmp[x] & 0xff00) >> 8);
+		tmp[x] = (tmp[x] << 8) | ((tmp[x] & 0xff00) >> 8);
 #endif
 
-		}
-		if ((fwrite(tmp, 1, f->datalen, fs->f) != f->datalen) ) {
-			ast_log(LOG_WARNING, "Bad write (%d): %s\n", res, strerror(errno));
-			return -1;
-		}
-	} else {
-		ast_log(LOG_WARNING, "Cannot write data to file.\n");
+	}
+	if ((fwrite(tmp, 1, f->datalen, fs->f) != f->datalen) ) {
+		ast_log(LOG_WARNING, "Bad write (%d): %s\n", res, strerror(errno));
 		return -1;
 	}
-	
-	fs->bytes += f->datalen;
+
+	s->bytes += f->datalen;
 	update_header(fs->f);
 		
 	return 0;
@@ -562,43 +500,45 @@
 	return (offset - 44)/2;
 }
 
-static char *wav_getcomment(struct ast_filestream *s)
-{
-	return NULL;
-}
+static struct ast_format_lock me = { .usecnt = -1 };
 
+static const struct ast_format wav_f = {
+	.name = "wav",
+	.exts = "wav",
+	.format = AST_FORMAT_SLINEAR,
+	.open =	wav_open,
+	.rewrite = wav_rewrite,
+	.write = wav_write,
+	.seek = wav_seek,
+	.trunc = wav_trunc,
+	.tell =	wav_tell,
+	.read = wav_read,
+	.close = wav_close,
+	.buf_size = WAV_BUF_SIZE + AST_FRIENDLY_OFFSET,
+	.desc_size = sizeof(struct wav_desc),
+	.lockp = &me,
+};
+
 int load_module()
 {
-	return ast_format_register(name, exts, AST_FORMAT_SLINEAR,
-								wav_open,
-								wav_rewrite,
-								wav_write,
-								wav_seek,
-								wav_trunc,
-								wav_tell,
-								wav_read,
-								wav_close,
-								wav_getcomment);
-								
-								
+	return ast_format_register(&wav_f);
 }
 
 int unload_module()
 {
-	return ast_format_unregister(name);
+	return ast_format_unregister(wav_f.name);
 }	
 
 int usecount()
 {
-	return glistcnt;
+	return me.usecnt;
 }
 
 char *description()
 {
-	return desc;
+	return "Microsoft WAV format (8000hz Signed Linear)";
 }
 
-
 char *key()
 {
 	return ASTERISK_GPL_KEY;
Index: formats/format_ogg_vorbis.c
===================================================================
--- formats/format_ogg_vorbis.c	(revision 10193)
+++ formats/format_ogg_vorbis.c	(working copy)
@@ -51,11 +51,7 @@
 #define SAMPLES_MAX 160
 #define BLOCK_SIZE 4096
 
-struct ast_filestream {
-	void *reserved[AST_RESERVED_POINTERS];
-	
-	FILE *f;
-	
+struct vorbis_desc {
 	/* structures for handling the Ogg container */
 	ogg_sync_state oy;
 	ogg_stream_state os;
@@ -73,14 +69,6 @@
 	
 	/*! \brief Indicates whether an End of Stream condition has been detected. */
 	int eos;
-	
-	/*! \brief Buffer to hold audio data. */
-	short buffer[SAMPLES_MAX];
-	
-	/*! \brief Asterisk frame object. */
-	struct ast_frame fr;
-	char waste[AST_FRIENDLY_OFFSET];
-	char empty;
 };
 
 AST_MUTEX_DEFINE_STATIC(ogg_vorbis_lock);
@@ -96,176 +84,123 @@
  * \param f File that points to on disk storage of the OGG/Vorbis data.
  * \return The new filestream.
  */
-static struct ast_filestream *ogg_vorbis_open(FILE * f)
+static int ogg_vorbis_open(struct ast_filestream *s)
 {
 	int i;
 	int bytes;
 	int result;
 	char **ptr;
 	char *buffer;
+	struct vorbis_desc *tmp = (struct vorbis_desc *)s->private;
 
-	struct ast_filestream *tmp;
+	tmp->writing = 0;
+	tmp->f = f;
 
-	if ((tmp = malloc(sizeof(struct ast_filestream)))) {
-		memset(tmp, 0, sizeof(struct ast_filestream));
+	ogg_sync_init(&tmp->oy);
 
-		tmp->writing = 0;
-		tmp->f = f;
+	buffer = ogg_sync_buffer(&tmp->oy, BLOCK_SIZE);
+	bytes = fread(buffer, 1, BLOCK_SIZE, f);
+	ogg_sync_wrote(&tmp->oy, bytes);
 
-		ogg_sync_init(&tmp->oy);
-
-		buffer = ogg_sync_buffer(&tmp->oy, BLOCK_SIZE);
-		bytes = fread(buffer, 1, BLOCK_SIZE, f);
-		ogg_sync_wrote(&tmp->oy, bytes);
-
-		result = ogg_sync_pageout(&tmp->oy, &tmp->og);
-		if (result != 1) {
-			if (bytes < BLOCK_SIZE) {
-				ast_log(LOG_ERROR, "Run out of data...\n");
-			} else {
-				ast_log(LOG_ERROR,
-						"Input does not appear to be an Ogg bitstream.\n");
-			}
-			fclose(f);
-			ogg_sync_clear(&tmp->oy);
-			free(tmp);
-			return NULL;
+	result = ogg_sync_pageout(&tmp->oy, &tmp->og);
+	if (result != 1) {
+		if(bytes < BLOCK_SIZE) {
+			ast_log(LOG_ERROR, "Run out of data...\n");
+		} else {
+			ast_log(LOG_ERROR, "Input does not appear to be an Ogg bitstream.\n");
 		}
+		ogg_sync_clear(&tmp->oy);
+		return -1;
+	}
+	
+	ogg_stream_init(&tmp->os, ogg_page_serialno(&tmp->og));
+	vorbis_info_init(&tmp->vi);
+	vorbis_comment_init(&tmp->vc);
 
-		ogg_stream_init(&tmp->os, ogg_page_serialno(&tmp->og));
-		vorbis_info_init(&tmp->vi);
-		vorbis_comment_init(&tmp->vc);
-
-		if (ogg_stream_pagein(&tmp->os, &tmp->og) < 0) {
-			ast_log(LOG_ERROR,
-					"Error reading first page of Ogg bitstream data.\n");
-			fclose(f);
-			ogg_stream_clear(&tmp->os);
-			vorbis_comment_clear(&tmp->vc);
-			vorbis_info_clear(&tmp->vi);
-			ogg_sync_clear(&tmp->oy);
-			free(tmp);
-			return NULL;
-		}
-
-		if (ogg_stream_packetout(&tmp->os, &tmp->op) != 1) {
-			ast_log(LOG_ERROR, "Error reading initial header packet.\n");
-			fclose(f);
-			ogg_stream_clear(&tmp->os);
-			vorbis_comment_clear(&tmp->vc);
-			vorbis_info_clear(&tmp->vi);
-			ogg_sync_clear(&tmp->oy);
-			free(tmp);
-			return NULL;
-		}
-
-		if (vorbis_synthesis_headerin(&tmp->vi, &tmp->vc, &tmp->op) < 0) {
-			ast_log(LOG_ERROR, "This Ogg bitstream does not contain Vorbis audio data.\n");
-			fclose(f);
-			ogg_stream_clear(&tmp->os);
-			vorbis_comment_clear(&tmp->vc);
-			vorbis_info_clear(&tmp->vi);
-			ogg_sync_clear(&tmp->oy);
-			free(tmp);
-			return NULL;
-		}
-
-		i = 0;
+	if (ogg_stream_pagein(&tmp->os, &tmp->og) < 0) { 
+		ast_log(LOG_ERROR, "Error reading first page of Ogg bitstream data.\n");
+error:
+		ogg_stream_clear(&tmp->os);
+		vorbis_comment_clear(&tmp->vc);
+		vorbis_info_clear(&tmp->vi);
+		ogg_sync_clear(&tmp->oy);
+		return -1;
+	}
+	
+	if (ogg_stream_packetout(&tmp->os, &tmp->op) != 1) { 
+		ast_log(LOG_ERROR, "Error reading initial header packet.\n");
+		goto error;
+	}
+	
+	if (vorbis_synthesis_headerin(&tmp->vi, &tmp->vc, &tmp->op) < 0) { 
+		ast_log(LOG_ERROR, "This Ogg bitstream does not contain Vorbis audio data.\n");
+		goto error;
+	}
+	
+	for (i = 0; i < 2 ; ) {
 		while (i < 2) {
-			while (i < 2) {
-				result = ogg_sync_pageout(&tmp->oy, &tmp->og);
-				if (result == 0)
-					break;
-				if (result == 1) {
-					ogg_stream_pagein(&tmp->os, &tmp->og);
-					while (i < 2) {
-						result = ogg_stream_packetout(&tmp->os, &tmp->op);
-						if (result == 0)
-							break;
-						if (result < 0) {
-							ast_log(LOG_ERROR, "Corrupt secondary header.  Exiting.\n");
-							fclose(f);
-							ogg_stream_clear(&tmp->os);
-							vorbis_comment_clear(&tmp->vc);
-							vorbis_info_clear(&tmp->vi);
-							ogg_sync_clear(&tmp->oy);
-							free(tmp);
-							return NULL;
-						}
-						vorbis_synthesis_headerin(&tmp->vi, &tmp->vc, &tmp->op);
-						i++;
+			result = ogg_sync_pageout(&tmp->oy, &tmp->og);
+			if (result == 0)
+				break;
+			if (result == 1) {
+				ogg_stream_pagein(&tmp->os, &tmp->og);
+				while(i < 2) {
+					result = ogg_stream_packetout(&tmp->os,&tmp->op);
+					if(result == 0)
+						break;
+					if(result < 0) {
+						ast_log(LOG_ERROR, "Corrupt secondary header.  Exiting.\n");
+						goto error;
 					}
+					vorbis_synthesis_headerin(&tmp->vi, &tmp->vc, &tmp->op);
+					i++;
 				}
 			}
-
-			buffer = ogg_sync_buffer(&tmp->oy, BLOCK_SIZE);
-			bytes = fread(buffer, 1, BLOCK_SIZE, f);
-			if (bytes == 0 && i < 2) {
-				ast_log(LOG_ERROR, "End of file before finding all Vorbis headers!\n");
-				fclose(f);
-				ogg_stream_clear(&tmp->os);
-				vorbis_comment_clear(&tmp->vc);
-				vorbis_info_clear(&tmp->vi);
-				ogg_sync_clear(&tmp->oy);
-				free(tmp);
-				return NULL;
-			}
-			ogg_sync_wrote(&tmp->oy, bytes);
 		}
 
-		ptr = tmp->vc.user_comments;
-		while (*ptr) {
-			ast_log(LOG_DEBUG, "OGG/Vorbis comment: %s\n", *ptr);
-			++ptr;
+		buffer = ogg_sync_buffer(&tmp->oy, BLOCK_SIZE);
+		bytes = fread(buffer, 1, BLOCK_SIZE, f);
+		if(bytes == 0 && i < 2) {
+			ast_log(LOG_ERROR, "End of file before finding all Vorbis headers!\n");
+			goto error;
 		}
-		ast_log(LOG_DEBUG, "OGG/Vorbis bitstream is %d channel, %ldHz\n",
-			tmp->vi.channels, tmp->vi.rate);
-		ast_log(LOG_DEBUG, "OGG/Vorbis file encoded by: %s\n",
-			tmp->vc.vendor);
+		ogg_sync_wrote(&tmp->oy, bytes);
+	}
+	
+	ptr = tmp->vc.user_comments;
+	while(*ptr){
+		ast_log(LOG_DEBUG, "OGG/Vorbis comment: %s\n", *ptr);
+		++ptr;
+	}
+	ast_log(LOG_DEBUG, "OGG/Vorbis bitstream is %d channel, %ldHz\n", tmp->vi.channels, tmp->vi.rate);
+	ast_log(LOG_DEBUG, "OGG/Vorbis file encoded by: %s\n", tmp->vc.vendor);
 
-		if (tmp->vi.channels != 1) {
-			ast_log(LOG_ERROR, "Only monophonic OGG/Vorbis files are currently supported!\n");
-			ogg_stream_clear(&tmp->os);
-			vorbis_comment_clear(&tmp->vc);
-			vorbis_info_clear(&tmp->vi);
-			ogg_sync_clear(&tmp->oy);
-			free(tmp);
-			return NULL;
-		}
+	if(tmp->vi.channels != 1) {
+		ast_log(LOG_ERROR, "Only monophonic OGG/Vorbis files are currently supported!\n");
+		goto error;
+	}
+	
 
-		if (tmp->vi.rate != 8000) {
-			ast_log(LOG_ERROR, "Only 8000Hz OGG/Vorbis files are currently supported!\n");
-			fclose(f);
-			ogg_stream_clear(&tmp->os);
-			vorbis_block_clear(&tmp->vb);
-			vorbis_dsp_clear(&tmp->vd);
-			vorbis_comment_clear(&tmp->vc);
-			vorbis_info_clear(&tmp->vi);
-			ogg_sync_clear(&tmp->oy);
-			free(tmp);
-			return NULL;
-		}
+	if(tmp->vi.rate != 8000) {
+		ast_log(LOG_ERROR, "Only 8000Hz OGG/Vorbis files are currently supported!\n");
+		vorbis_block_clear(&tmp->vb);
+		vorbis_dsp_clear(&tmp->vd);
+		goto error;
+	}
+	
+	vorbis_synthesis_init(&tmp->vd, &tmp->vi);
+	vorbis_block_init(&tmp->vd, &tmp->vb);
 
-		vorbis_synthesis_init(&tmp->vd, &tmp->vi);
-		vorbis_block_init(&tmp->vd, &tmp->vb);
-
-		if (ast_mutex_lock(&ogg_vorbis_lock)) {
-			ast_log(LOG_WARNING, "Unable to lock ogg_vorbis list\n");
-			fclose(f);
-			ogg_stream_clear(&tmp->os);
-			vorbis_block_clear(&tmp->vb);
-			vorbis_dsp_clear(&tmp->vd);
-			vorbis_comment_clear(&tmp->vc);
-			vorbis_info_clear(&tmp->vi);
-			ogg_sync_clear(&tmp->oy);
-			free(tmp);
-			return NULL;
-		}
-		glistcnt++;
-		ast_mutex_unlock(&ogg_vorbis_lock);
-		ast_update_use_count();
+	if(ast_mutex_lock(&ogg_vorbis_lock)) {
+		ast_log(LOG_WARNING, "Unable to lock ogg_vorbis list\n");
+		vorbis_block_clear(&tmp->vb);
+		vorbis_dsp_clear(&tmp->vd);
+		goto error;
 	}
-	return tmp;
+	glistcnt++;
+	ast_mutex_unlock(&ogg_vorbis_lock);
+	ast_update_use_count();
+return 0;
 }
 
 /*!
@@ -440,9 +375,6 @@
 	if (s->writing) {
 		ogg_sync_clear(&s->oy);
 	}
-
-	fclose(s->f);
-	free(s);
 }
 
 /*!
@@ -645,18 +577,28 @@
 	return NULL;
 }
 
+static struct ast_format_lock me = { .usecnt = -1 };
+
+static const struct ast_format vorbis_f = {
+	.name =
+	.ext =
+	.format = AST_FORMAT_SLINEAR,
+	.open = ogg_vorbis_open,
+	.rewrite = ogg_vorbis_rewrite,
+	.write = ogg_vorbis_write,
+	.seek =	ogg_vorbis_seek,
+	.trunc = ogg_vorbis_trunc,
+	.tell = ogg_vorbis_tell,
+	.read = ogg_vorbis_read,
+	.close = ogg_vorbis_close,
+	.buf_sie = BUF_SIZE + AST_FRIENDLY_OFFSET,
+	.desc_size = sizeof(struct vorbis_desc),
+	.lockp = &me,
+};
+
 int load_module()
 {
-	return ast_format_register(name, exts, AST_FORMAT_SLINEAR,
-				   ogg_vorbis_open,
-				   ogg_vorbis_rewrite,
-				   ogg_vorbis_write,
-				   ogg_vorbis_seek,
-				   ogg_vorbis_trunc,
-				   ogg_vorbis_tell,
-				   ogg_vorbis_read,
-				   ogg_vorbis_close,
-				   ogg_vorbis_getcomment);
+	return ast_format_register(&vorbis_f);
 }
 
 int unload_module()
@@ -666,7 +608,7 @@
 
 int usecount()
 {
-	return glistcnt;
+	return me.usecnt;
 }
 
 char *description()
Index: formats/format_wav_gsm.c
===================================================================
--- formats/format_wav_gsm.c	(revision 10193)
+++ formats/format_wav_gsm.c	(working copy)
@@ -54,6 +54,12 @@
 
 /* Portions of the conversion code are by guido@sienanet.it */
 
+#define	GSM_FRAME_SIZE	33
+#define	MSGSM_FRAME_SIZE	65
+#define	MSGSM_DATA_OFS		60	/* offset of data bytes */
+#define	GSM_SAMPLES		160	/* samples in a GSM block */
+#define	MSGSM_SAMPLES		(2*GSM_SAMPLES)	/* samples in an MSGSM block */
+
 /* begin binary data: */
 char msgsm_silence[] = /* 65 */
 {0x48,0x17,0xD6,0x84,0x02,0x80,0x24,0x49,0x92,0x24,0x89,0x02,0x80,0x24,0x49
@@ -63,29 +69,12 @@
 ,0x92,0x24,0x49,0x92,0x00};
 /* end binary data. size = 65 bytes */
 
-struct ast_filestream {
-	void *reserved[AST_RESERVED_POINTERS];
+struct wavg_desc {
 	/* Believe it or not, we must decode/recode to account for the
 	   weird MS format */
-	/* This is what a filestream means to us */
-	FILE *f; /* Descriptor */
-	struct ast_frame fr;				/* Frame information */
-	char waste[AST_FRIENDLY_OFFSET];	/* Buffer for sending frames, etc */
-	char empty;							/* Empty character */
-	unsigned char gsm[66];				/* Two Real GSM Frames */
-	int foffset;
 	int secondhalf;						/* Are we on the second half */
-	struct timeval last;
 };
 
-
-AST_MUTEX_DEFINE_STATIC(wav_lock);
-static int glistcnt = 0;
-
-static char *name = "wav49";
-static char *desc = "Microsoft WAV format (Proprietary GSM)";
-static char *exts = "WAV|wav49";
-
 #if __BYTE_ORDER == __LITTLE_ENDIAN
 #define htoll(b) (b)
 #define htols(b) (b)
@@ -236,7 +225,7 @@
 	fseek(f, 0, SEEK_END);
 	end = ftell(f);
 	/* in a gsm WAV, data starts 60 bytes in */
-	bytes = end - 60;
+	bytes = end - MSGSM_DATA_OFS;
 	datalen = htoll((bytes + 1) & ~0x1);
 	filelen = htoll(52 + ((bytes + 1) & ~0x1));
 	if (cur < 0) {
@@ -347,119 +336,78 @@
 	return 0;
 }
 
-static struct ast_filestream *wav_open(FILE *f)
+static int wav_open(struct ast_filestream *s)
 {
 	/* We don't have any header to read or anything really, but
 	   if we did, it would go here.  We also might want to check
 	   and be sure it's a valid file.  */
-	struct ast_filestream *tmp;
-	if ((tmp = malloc(sizeof(struct ast_filestream)))) {
-		memset(tmp, 0, sizeof(struct ast_filestream));
-		if (check_header(f)) {
-			free(tmp);
-			return NULL;
-		}
-		if (ast_mutex_lock(&wav_lock)) {
-			ast_log(LOG_WARNING, "Unable to lock wav list\n");
-			free(tmp);
-			return NULL;
-		}
-		tmp->f = f;
-		tmp->fr.data = tmp->gsm;
-		tmp->fr.frametype = AST_FRAME_VOICE;
-		tmp->fr.subclass = AST_FORMAT_GSM;
-		/* datalen will vary for each frame */
-		tmp->fr.src = name;
-		tmp->fr.mallocd = 0;
-		tmp->secondhalf = 0;
-		glistcnt++;
-		ast_mutex_unlock(&wav_lock);
-		ast_update_use_count();
-	}
-	return tmp;
+	struct wavg_desc *fs = (struct wavg_desc *)s->private;
+
+	if (check_header(s->f))
+		return -1;
+	fs->secondhalf = 0;	/* not strictly necessary */
+	return 0;
 }
 
-static struct ast_filestream *wav_rewrite(FILE *f, const char *comment)
+static int wav_rewrite(struct ast_filestream *s, const char *comment)
 {
 	/* We don't have any header to read or anything really, but
 	   if we did, it would go here.  We also might want to check
 	   and be sure it's a valid file.  */
-	struct ast_filestream *tmp;
-	if ((tmp = malloc(sizeof(struct ast_filestream)))) {
-		memset(tmp, 0, sizeof(struct ast_filestream));
-		if (write_header(f)) {
-			free(tmp);
-			return NULL;
-		}
-		if (ast_mutex_lock(&wav_lock)) {
-			ast_log(LOG_WARNING, "Unable to lock wav list\n");
-			free(tmp);
-			return NULL;
-		}
-		tmp->f = f;
-		glistcnt++;
-		ast_mutex_unlock(&wav_lock);
-		ast_update_use_count();
-	} else
-		ast_log(LOG_WARNING, "Out of memory\n");
-	return tmp;
+
+	if (write_header(s->f))
+		return -1;
+	return 0;
 }
 
 static void wav_close(struct ast_filestream *s)
 {
 	char zero = 0;
-	if (ast_mutex_lock(&wav_lock)) {
-		ast_log(LOG_WARNING, "Unable to lock wav list\n");
-		return;
-	}
-	glistcnt--;
-	ast_mutex_unlock(&wav_lock);
-	ast_update_use_count();
 	/* Pad to even length */
 	fseek(s->f, 0, SEEK_END);
 	if (ftell(s->f) & 0x1)
 		fwrite(&zero, 1, 1, s->f);
-	fclose(s->f);
-	free(s);
-	s = NULL;
 }
 
 static struct ast_frame *wav_read(struct ast_filestream *s, int *whennext)
 {
-	int res;
-	char msdata[66];
 	/* Send a frame from the file to the appropriate channel */
+	struct wavg_desc *fs = (struct wavg_desc *)s->private;
 
 	s->fr.frametype = AST_FRAME_VOICE;
 	s->fr.subclass = AST_FORMAT_GSM;
 	s->fr.offset = AST_FRIENDLY_OFFSET;
-	s->fr.samples = 160;
-	s->fr.datalen = 33;
+	s->fr.samples = GSM_SAMPLES;
 	s->fr.mallocd = 0;
-	if (s->secondhalf) {
+	FR_SET_BUF(&s->fr, s->buf, AST_FRIENDLY_OFFSET, GSM_FRAME_SIZE);
+	if (fs->secondhalf) {
 		/* Just return a frame based on the second GSM frame */
-		s->fr.data = s->gsm + 33;
+		s->fr.data = (char *)s->fr.data + GSM_FRAME_SIZE;
+		s->fr.offset += GSM_FRAME_SIZE;
 	} else {
-		if ((res = fread(msdata, 1, 65, s->f)) != 65) {
+		/* read and convert */
+		char msdata[MSGSM_FRAME_SIZE];
+		int res;
+		
+		if ((res = fread(msdata, 1, MSGSM_FRAME_SIZE, s->f)) != MSGSM_FRAME_SIZE) {
 			if (res && (res != 1))
 				ast_log(LOG_WARNING, "Short read (%d) (%s)!\n", res, strerror(errno));
 			return NULL;
 		}
 		/* Convert from MS format to two real GSM frames */
-		conv65(msdata, s->gsm);
-		s->fr.data = s->gsm;
+		conv65(msdata, s->fr.data);
 	}
-	s->secondhalf = !s->secondhalf;
-	*whennext = 160;
+	fs->secondhalf = !fs->secondhalf;
+	*whennext = GSM_SAMPLES;
 	return &s->fr;
 }
 
-static int wav_write(struct ast_filestream *fs, struct ast_frame *f)
+static int wav_write(struct ast_filestream *s, struct ast_frame *f)
 {
-	int res;
-	char msdata[66];
-	int len =0;
-	int alreadyms=0;
+	int len;
+	int size;
+	struct wavg_desc *fs = (struct wavg_desc *)s->private;
+
 	if (f->frametype != AST_FRAME_VOICE) {
 		ast_log(LOG_WARNING, "Asked to write non-voice frame!\n");
 		return -1;
@@ -468,65 +416,70 @@
 		ast_log(LOG_WARNING, "Asked to write non-GSM frame (%d)!\n", f->subclass);
 		return -1;
 	}
-	if (!(f->datalen % 65)) 
-		alreadyms = 1;
-	while(len < f->datalen) {
-		if (alreadyms) {
+	/* XXX this might fail... if the input is a multiple of MSGSM_FRAME_SIZE
+	 * we assume it is already in the correct format.
+	 */
+	if (!(f->datalen % MSGSM_FRAME_SIZE)) {
+		size = MSGSM_FRAME_SIZE;
+		fs->secondhalf = 0;
+	} else {
+		size = GSM_FRAME_SIZE;
+	}
+	for (len = 0; len < f->datalen ; len += size) {
+		int res;
+		char *src, msdata[MSGSM_FRAME_SIZE];
+		if (fs->secondhalf) {	/* second half of raw gsm to be converted */
+			memcpy(s->buf + GSM_FRAME_SIZE, f->data + len, GSM_FRAME_SIZE);
+			conv66(s->buf, msdata);
+			src = msdata;
 			fs->secondhalf = 0;
-			if ((res = fwrite(f->data + len, 1, 65, fs->f)) != 65) {
-				ast_log(LOG_WARNING, "Bad write (%d/65): %s\n", res, strerror(errno));
-				return -1;
-			}
-			update_header(fs->f);
-			len += 65;
-		} else {
-			if (fs->secondhalf) {
-				memcpy(fs->gsm + 33, f->data + len, 33);
-				conv66(fs->gsm, msdata);
-				if ((res = fwrite(msdata, 1, 65, fs->f)) != 65) {
-					ast_log(LOG_WARNING, "Bad write (%d/65): %s\n", res, strerror(errno));
-					return -1;
-				}
-				update_header(fs->f);
-			} else {
-				/* Copy the data and do nothing */
-				memcpy(fs->gsm, f->data + len, 33);
-			}
-			fs->secondhalf = !fs->secondhalf;
-			len += 33;
+		} else if (size == GSM_FRAME_SIZE) {	/* first half of raw gsm */
+			memcpy(s->buf, f->data + len, GSM_FRAME_SIZE);
+			src = NULL;	/* nothing to write */
+			fs->secondhalf = 1;
+		} else {	/* raw msgsm data */
+			src = f->data + len;
 		}
+		if (src && (res = fwrite(src, 1, size, s->f)) != size) {
+			ast_log(LOG_WARNING, "Bad write (%d/65): %s\n", res, strerror(errno));
+			return -1;
+		}
+		update_header(s->f); /* XXX inefficient! */
 	}
 	return 0;
 }
 
 static int wav_seek(struct ast_filestream *fs, long sample_offset, int whence)
 {
-	off_t offset=0,distance,cur,min,max;
-	min = 60;
-	cur = ftell(fs->f);
+	off_t offset=0, distance, max;
+	struct wavg_desc *s = (struct wavg_desc *)fs->private;
+
+	off_t min = MSGSM_DATA_OFS;
+	off_t cur = ftell(fs->f);
 	fseek(fs->f, 0, SEEK_END);
-	max = ftell(fs->f);
-	/* I'm getting sloppy here, I'm only going to go to even splits of the 2
-	 * frames, if you want tighter cuts use format_gsm, format_pcm, or format_wav */
-	distance = (sample_offset/320) * 65;
-	if(whence == SEEK_SET)
+	max = ftell(fs->f);	/* XXX ideally, should round correctly */
+	/* Compute the distance in bytes, rounded to the block size */
+	distance = (sample_offset/MSGSM_SAMPLES) * MSGSM_FRAME_SIZE;
+	if (whence == SEEK_SET)
 		offset = distance + min;
-	else if(whence == SEEK_CUR || whence == SEEK_FORCECUR)
+	else if (whence == SEEK_CUR || whence == SEEK_FORCECUR)
 		offset = distance + cur;
-	else if(whence == SEEK_END)
+	else if (whence == SEEK_END)
 		offset = max - distance;
 	/* always protect against seeking past end of header */
-	offset = (offset < min)?min:offset;
+	if (offset < min)
+		offset = min;
 	if (whence != SEEK_FORCECUR) {
-		offset = (offset > max)?max:offset;
+		if (offset > max)
+			offset = max;
 	} else if (offset > max) {
 		int i;
 		fseek(fs->f, 0, SEEK_END);
-		for (i=0; i< (offset - max) / 65; i++) {
-			fwrite(msgsm_silence, 1, 65, fs->f);
+		for (i=0; i< (offset - max) / MSGSM_FRAME_SIZE; i++) {
+			fwrite(msgsm_silence, 1, MSGSM_FRAME_SIZE, fs->f);
 		}
 	}
-	fs->secondhalf = 0;
+	s->secondhalf = 0;
 	return fseek(fs->f, offset, SEEK_SET);
 }
 
@@ -543,46 +496,49 @@
 	offset = ftell(fs->f);
 	/* since this will most likely be used later in play or record, lets stick
 	 * to that level of resolution, just even frames boundaries */
-	return (offset - 52)/65*320;
+	/* XXX why 52 ? */
+	return (offset - 52)/MSGSM_FRAME_SIZE*MSGSM_SAMPLES;
 }
 
-static char *wav_getcomment(struct ast_filestream *s)
-{
-	return NULL;
-}
+static struct ast_format_lock me = { .usecnt = -1 };
 
+static const struct ast_format wav49_f = {
+	.name = "wav49",
+	.exts = "WAV|wav49",
+	.format = AST_FORMAT_GSM,
+	.open =	wav_open,
+	.rewrite = wav_rewrite,
+	.write = wav_write,
+	.seek = wav_seek,
+	.trunc = wav_trunc,
+	.tell = wav_tell,
+	.read = wav_read,
+	.close = wav_close,
+	.buf_size = 2*GSM_FRAME_SIZE + AST_FRIENDLY_OFFSET,
+	.desc_size = sizeof(struct wavg_desc),
+	.lockp = &me,
+};
+
 int load_module()
 {
-	return ast_format_register(name, exts, AST_FORMAT_GSM,
-								wav_open,
-								wav_rewrite,
-								wav_write,
-								wav_seek,
-								wav_trunc,
-								wav_tell,
-								wav_read,
-								wav_close,
-								wav_getcomment);
-								
-								
+	return ast_format_register(&wav49_f);
 }
 
 int unload_module()
 {
-	return ast_format_unregister(name);
+	return ast_format_unregister(wav49_f.name);
 }	
 
 int usecount()
 {
-	return glistcnt;
+	return me.usecnt;
 }
 
 char *description()
 {
-	return desc;
+	return "Microsoft WAV format (Proprietary GSM)";
 }
 
-
 char *key()
 {
 	return ASTERISK_GPL_KEY;
